#pragma once

#include "StringBuffer.h"

class CPathUtility
{
public:
	static CStringBuffer Append(const TCHAR* sBasePath, const TCHAR* sAddPath)
	{
		CStringBuffer result = sBasePath;
		result.SetBufferLength(MAX_PATH);
		PathAppend(result.GetBuffer(), sAddPath);
		return result;
	}

	static CStringBuffer GetModulePath()
	{
		CStringBuffer modulePath;
		modulePath.SetBufferLength(MAX_PATH);
		GetModuleFileName(NULL, modulePath.GetBuffer(), modulePath.GetBufferLength());
		CStringBuffer result;
		result.SetBufferLength(MAX_PATH);
		GetFullPathName(modulePath, result.GetBufferLength(), result.GetBuffer(), NULL);
		return result;
	}

	static CStringBuffer GetParentFolder(const TCHAR* path)
	{
		CStringBuffer result = path;
		PathRemoveFileSpec(result.GetBuffer());
		return result;
	}

	static CStringBuffer GetSpecialFolder(int nCsidl)
	{
		CStringBuffer result;

		LPMALLOC pMalloc = NULL;
		LPITEMIDLIST pItemList = NULL;
		HRESULT nResult = ::SHGetMalloc(&pMalloc);
		if(FAILED(nResult))
		{
			return result;
		}

		nResult = ::SHGetSpecialFolderLocation(NULL, nCsidl, &pItemList);
		if(SUCCEEDED(nResult))
		{
			result.SetBufferLength(MAX_PATH);
			::SHGetPathFromIDList(pItemList, result.GetBuffer());
			pMalloc->Free(pItemList);
		}
		pMalloc->Release();
		return result;
	}

};
